<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><META http-equiv="Content-Type" content="text/html; charset=UTF-8"><title>iText Tutorial: Table of Contents</title><meta name="Description" content="Examples and tutorial for using iText, a free Java-Pdf library"><meta name="Keywords" content="PDF, JAVA, iText, examples, Lowagie, Bruno"><link rel="stylesheet" href="./style.css" type="text/css"></head><body><a name="top" class="logo" href="http://www.lowagie.com/iText"><img src="http://www.lowagie.com/iText/images/logo.gif" border="0" alt="iText"></a><h1>Tutorial: iText by Example</h1><h2>Table of Contents</h2><div id="content"><div class="title">Introduction:</div><a href="http://itext.ugent.be/itext-in-action/"><img align="right" border="0" src="http://itext.ugent.be/img/lowagie_3d.jpg"></a><blockquote><p>
		iText is a library that allows developers to extend the capabilities of
		their web server (and other JAVA) applications with dynamic PDF document
		generation. In this tutorial, you will find lots of standalone examples
		to learn how to use most of the iText functionality and features.
		It should be easy to integrate most of the solutions in a Servlet, a
		Java Web Start application or some other Java program.
	</p><p>This tutorial is far from complete; for a more comprehensive
					overview of iText's functionality, please buy the book
					<a href="http://itext.ugent.be/itext-in-action/">iText in Action</a>.
					You can also download the first and third chapter for free from
					<a href="http://www.manning.com/affiliate/idevaffiliate.php?id=223_53">http://manning.com/lowagie/</a>.</p></blockquote><div class="title">Table of contents of this online tutorial</div><br><ul><li><a href="#part1"><div class="subtitle">Part I: General Use of iText</div></a></li><li><a href="#part2"><div class="subtitle">Part II: Using Basic Building Blocks</div></a></li><li><a href="#part3"><div class="subtitle">Part III: Fonts</div></a></li><li><a href="#part4"><div class="subtitle">Part IV: Direct Content</div></a></li><li><a href="#part5"><div class="subtitle">Part V: Interactive Features (AcroForms)</div></a></li><li><a href="#part6"><div class="subtitle">Part VI: RTF</div></a></li></ul><br><br><a name="part1"></a><div class="title">Part I: General Use of iText</div><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="general/index.html" name="general">Hello World</a>How-to generate a PDF document with iText in 5 easy steps.</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="general/index.html#inaction" class="small">In the book</a></li><li><a href="general/index.html#5steps" class="small">Creating a document in 5 steps.</a></li><li><a href="general/index.html#step1" class="small">step 1: the Document object</a></li><li><a href="general/index.html#step2" class="small">step 2: the Writer object</a></li><li><a href="general/index.html#step3" class="small">step 3: opening the document</a></li><li><a href="general/index.html#step4" class="small">step 4: adding content</a></li><li><a href="general/index.html#step5" class="small">step 5: closing the document</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/general/HelloWorld.java">HelloWorld</a><br><div class="description">Generates a simple 'Hello World' PDF file</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/HelloWorld.pdf">HelloWorld.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/general/DefaultPageSize.java">DefaultPageSize</a><br><div class="description">Generates a PDF document with the default page size and some other predefined standard pagesizes</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/DefaultPageSize.pdf">DefaultPageSize.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/general/LandscapePortrait.java">LandscapePortrait</a><br><div class="description">Generates a PDF document with the first page in Lanscape; the second page in Portrait</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/LandscapePortrait.pdf">LandscapePortrait.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/general/CustomPageSize.java">CustomPageSize</a><br><div class="description">Generates a PDF document with a custom pagesize and backgroundcolor</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/CustomPageSize.pdf">CustomPageSize.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/general/Margins.java">Margins</a><br><div class="description">Demonstrates the margin functionality</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/Margins.pdf">Margins.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/general/HelloSystemOut.java">HelloSystemOut</a><br><div class="description">Writes PDF output to System.out</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/HelloWorld.txt">HelloWorld.txt</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/general/HelloWorldMultiple.java">HelloWorldMultiple</a><br><div class="description">Writing to different writers at the same time; using pause() and resume()</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/HelloWorldPdf.pdf">HelloWorldPdf.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/HelloWorldRtf.rtf">HelloWorldRtf.rtf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/HelloWorldHtml.html">HelloWorldHtml.html</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/general/HelloEncrypted.java">HelloEncrypted</a><br><div class="description">Again a PDF with the text 'Hello World', but this time the document is encrypted. To read it, you need to know the userpassword: 'Hello'</div><div class="small">Extra jars needed:</div><ul><li>bcprov-jdk14-135.jar</li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/HelloEncrypted.pdf">HelloEncrypted.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/general/HelloWorldMeta.java">HelloWorldMeta</a><br><div class="description">Adding metadata to a new PDF document</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/HelloWorldMeta.pdf">HelloWorldMeta.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./general/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="general/webapp/index.html" name="general_webapp">iText in a Web Application</a>How-to use iText in Web Applications.</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="general/webapp/index.html#inaction" class="small">In the book</a></li><li><a href="general/webapp/index.html#MyJavaServer" class="small">MyJavaServer.com</a></li><li><a href="general/webapp/index.html#HelloWorld" class="small">Hello World</a></li><li><a href="general/webapp/index.html#timeout" class="small">Workaround for timeout problem</a></li><li><a href="general/webapp/index.html#silentprint" class="small">Silent printing</a></li><li><a href="general/webapp/index.html#JSP" class="small">Hello World JSP</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/general/webapp/HelloWorldServlet.java">HelloWorldServlet</a><br><div class="description">Generates a simple 'Hello World' file from a servlet (PDF, HTML or RTF)</div><div class="small">Extra jars needed:</div><ul><li>servlet.jar</li></ul><div class="small">Servlets/JSP:</div><ul><li><a href="http://blowagie.users.mcs2.netarray.com/servlet/HelloWorld?presentationtype=pdf">presentationtype=pdf</a></li><li><a href="http://blowagie.users.mcs2.netarray.com/servlet/HelloWorld?presentationtype=html">presentationtype=html</a></li><li><a href="http://blowagie.users.mcs2.netarray.com/servlet/HelloWorld?presentationtype=rtf">presentationtype=rtf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/general/webapp/OutSimplePdf.java">OutSimplePdf</a><br><div class="description">Generates a simple PDF file from a servlet. The file is buffered and served with the extension .pdf</div><div class="small">Extra jars needed:</div><ul><li>servlet.jar</li></ul><div class="small">Servlets/JSP:</div><ul><li><a href="http://blowagie.users.mcs2.netarray.com/servlet/simple.pdf">without message</a></li><li><a href="http://blowagie.users.mcs2.netarray.com/servlet/simple.pdf?msg=Hello+World">with message</a></li></ul></div><div class="example"><a class="source" href="http://cvs.sourceforge.net/viewcvs.py/*checkout*/itext/www/tutorial/general/webapp/UserAgent.jsp">UserAgent.jsp</a><br><div class="description">Looks at the user-agent: if MSIE on Windows, embed the PDF; if another browser, redirect to the servlet</div><div class="small">Servlets/JSP:</div><ul><li><a href="http://blowagie.users.mcs2.netarray.com/UserAgent.jsp">try this with different browsers</a></li></ul></div><div class="example"><a class="source" href="http://cvs.sourceforge.net/viewcvs.py/*checkout*/itext/www/tutorial/general/webapp/GetPost.jsp">GetPost.jsp</a><br><div class="description">Shows that PDF generation works with GET and POST</div><div class="small">Servlets/JSP:</div><ul><li><a href="http://blowagie.users.mcs2.netarray.com/GetPost.jsp?method=GET">GET</a></li><li><a href="http://blowagie.users.mcs2.netarray.com/GetPost.jsp?method=POST">POST</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/general/webapp/ProgressServlet.java">ProgressServlet</a><br><div class="description">Shows how to avoid receiving a timeout in your browser if generating the PDF takes a really long time.</div><div class="small">Extra jars needed:</div><ul><li>servlet.jar</li></ul><div class="small">Servlets/JSP:</div><ul><li><a href="http://blowagie.users.mcs2.netarray.com/servlet/progress">show progress</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/general/webapp/SilentPrintServlet.java">SilentPrintServlet</a><br><div class="description">Explains how to print silently via Servlet/Browser.</div><div class="small">Extra jars needed:</div><ul><li>servlet.jar</li></ul><div class="small">Servlets/JSP:</div><ul><li><a href="http://blowagie.users.mcs2.netarray.com/servlet/silentprint">try it!</a></li></ul></div><div class="example"><a class="source" href="http://cvs.sourceforge.net/viewcvs.py/*checkout*/itext/www/tutorial/general/webapp/HelloWorld.jsp">HelloWorld.jsp</a><br><div class="description">Generates a simple 'Hello World' file from a JSP page</div><div class="small">Servlets/JSP:</div><ul><li><a href="http://blowagie.users.mcs2.netarray.com/HelloWorld.jsp">HelloWorld</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./general/webapp/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="general/copystamp/index.html" name="general_copystamp">Manipulating existing PDF documents</a>How-to copy/manipulate existing PDF documents.</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="general/copystamp/index.html#inaction" class="small">In the book</a></li><li><a href="general/copystamp/index.html#intro" class="small">Introduction</a></li><li><a href="general/copystamp/index.html#pdfwriter" class="small">PdfWriter</a></li><li><a href="general/copystamp/index.html#pdfstamper" class="small">PdfStamper</a></li><li><a href="general/copystamp/index.html#pdfcopy" class="small">PdfCopy</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/TwoOnOne.java">TwoOnOne</a><br><div class="description">Combines 2 pages on 1</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/ChapterSection.pdf">ChapterSection.pdf</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/2on1.pdf">2on1.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/AddWatermarkPageNumbers.java">AddWatermarkPageNumbers</a><br><div class="description">Adds pagenumbers and a watermark to an existing document</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/ChapterSection.pdf">ChapterSection.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/SimpleAnnotations1.pdf">SimpleAnnotations1.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/watermark.jpg">watermark.jpg</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/watermark_pagenumbers.pdf">watermark_pagenumbers.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/Register.java">Register</a><br><div class="description">Fills in a form</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/SimpleRegistrationForm.pdf">SimpleRegistrationForm.pdf</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/registered.pdf">registered.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/registered_flat.pdf">registered_flat.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/EncryptorExample.java">EncryptorExample</a><br><div class="description">Encrypts an existing PDF file</div><div class="small">Extra jars needed:</div><ul><li>bcprov-jdk14-135.jar</li></ul><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/ChapterSection.pdf">ChapterSection.pdf</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/encrypted.pdf">encrypted.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/Concatenate.java">Concatenate</a><br><div class="description">Concatenates existing PDF files</div><div class="small">Argument(s):</div><ul><li>ChapterSection.pdf</li><li>Destinations.pdf</li><li>SimpleAnnotations1.pdf</li><li>concatenated.pdf</li></ul><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/ChapterSection.pdf">ChapterSection.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/Destinations.pdf">Destinations.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/SimpleAnnotations1.pdf">SimpleAnnotations1.pdf</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/concatenated.pdf">concatenated.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/ConcatenateForms.java">ConcatenateForms</a><br><div class="description">Concatenates existing PDF files with forms</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/SimpleRegistrationForm.pdf">SimpleRegistrationForm.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/TextFields.pdf">TextFields.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/ChapterSection.pdf">ChapterSection.pdf</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/copystamp/concatenatedforms.pdf">concatenatedforms.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./general/copystamp/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="general/faq/index.html" name="general_faq">Frequently Asked Questions</a>This is a basic technical reference that answers some frequently asked questions.</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="general/faq/index.html#inaction" class="small">In the book</a></li><li><a href="general/faq/index.html#measurements" class="small">Measurements</a></li><li><a href="general/faq/index.html#newpage" class="small">How to create a new page in iText</a></li><li><a href="general/faq/index.html#version" class="small">iText Version</a></li><li><a href="general/faq/index.html#pdfversion" class="small">PDF Version</a></li><li><a href="general/faq/index.html#portability" class="small">Why are there some strange characters in the PDF Header?</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/general/faq/Measurements.java">Measurements</a><br><div class="description">Demonstrates the measurement system (points, inches, centimeters)</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/faq/Measurements.pdf">Measurements.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/general/faq/NewPage.java">NewPage</a><br><div class="description">Shows how to go to a new page or insert a blank page</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/faq/NewPage.pdf">NewPage.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/general/faq/iTextVersion.java">iTextVersion</a><br><div class="description">Shows the iText version that was used to generate this example</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/faq/version.pdf">version.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/general/faq/PdfVersion.java">PdfVersion</a><br><div class="description">Change the PDF version of a document</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/general/faq/pdfversion.pdf">pdfversion.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./general/faq/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><a class="top" href="#top">Go to top of the page</a><a name="part2"></a><div class="title">Part II: Using Basic Building Blocks</div><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="objects/index.html" name="objects">Basic Text Objects</a>Some basic text objects that are used in iText.</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="objects/index.html#inaction" class="small">In the book</a></li><li><a href="objects/index.html#introduction" class="small">Introduction</a></li><li><a href="objects/index.html#chunk" class="small">The Chunk object</a></li><li><a href="objects/index.html#paragraph" class="small">The Paragraph object</a></li><li><a href="objects/index.html#phrase" class="small">The Phrase Object</a></li><li><a href="objects/index.html#list" class="small">The List object</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/Chunks.java">Chunks</a><br><div class="description">Demonstrates some Chunk functionality</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/Chunks.pdf">Chunks.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/DifferentFonts.java">DifferentFonts</a><br><div class="description">A Paragraph can contain text in different fonts</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/differentfonts.pdf">differentfonts.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/Paragraphs.java">Paragraphs</a><br><div class="description">Demonstrates some Paragraph functionality</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/Paragraphs.pdf">Paragraphs.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/SpaceWordRatio.java">SpaceWordRatio</a><br><div class="description">Space Word Ratio</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/spacewordratio.pdf">spacewordratio.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/ParagraphAttributes.java">ParagraphAttributes</a><br><div class="description">Demonstrates some more Paragraph functionality</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/ParagraphAttributes.pdf">ParagraphAttributes.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/Phrases.java">Phrases</a><br><div class="description">Demonstrates the different constructors of class Phrase</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/Phrases.pdf">Phrases.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/NegativeLeading.java">NegativeLeading</a><br><div class="description">Shows the effect of a negative leading</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/NegativeLeading.pdf">NegativeLeading.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/SymbolSubstitution.java">SymbolSubstitution</a><br><div class="description">Demonstrates how special characters are substituted by Symbols with Phrase.getInstance</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/SymbolSubstitution.pdf">SymbolSubstitution.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/FontSelection.java">FontSelection</a><br><div class="description">Selects the appropriate fonts that contain the glyphs needed to render text correctly</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/fontselection.pdf">fontselection.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/Lists.java">Lists</a><br><div class="description">Demonstrates some List functionality</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/lists.pdf">lists.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/lists.html">lists.html</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/FancyLists.java">FancyLists</a><br><div class="description">Demonstrates some List with Roman numerals, Greek letters, zapfdingbats,...</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/fancylists.pdf">fancylists.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./objects/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="objects/chunk/index.html" name="objects_chunk">The Chunk Object</a>Describes the functionality of the Chunk object.</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="objects/chunk/index.html#inaction" class="small">In the book</a></li><li><a href="objects/chunk/index.html#intro" class="small">Introduction</a></li><li><a href="objects/chunk/index.html#underline" class="small">Adding lines under, through or above a Chunk</a></li><li><a href="objects/chunk/index.html#subsup" class="small">Sub- and Superscript</a></li><li><a href="objects/chunk/index.html#background" class="small">Changing the background color</a></li><li><a href="objects/chunk/index.html#rendering" class="small">Stroking vs. Filling</a></li><li><a href="objects/chunk/index.html#skew" class="small">Skewing text</a></li><li><a href="objects/chunk/index.html#generic" class="small">Generic functionality</a></li><li><a href="objects/chunk/index.html#measure" class="small">Measuring and Scaling a Chunk</a></li><li><a href="objects/chunk/index.html#endline" class="small">When the end of a line is reached</a></li><li><a href="objects/chunk/index.html#more" class="small">To be continued...</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/Lines.java">Lines</a><br><div class="description">Demonstrates how to add lines under, through,... a Chunk</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/Lines.pdf">Lines.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/SubSupScript.java">SubSupScript</a><br><div class="description">Demonstrates the use of sub- and superscript</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/SubSupScript.pdf">SubSupScript.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/Background.java">Background</a><br><div class="description">How to change the background color of a Chunk</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/Background.pdf">Background.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/ChunkColor.java">ChunkColor</a><br><div class="description">Changing the color of a Chunk</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/ChunkColor.pdf">ChunkColor.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/Rendering.java">Rendering</a><br><div class="description">Some special rendering functionality</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/Rendering.pdf">Rendering.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/Skew.java">Skew</a><br><div class="description">Skewing Chunks</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/Skew.pdf">Skew.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/Generic.java">Generic</a><br><div class="description">Using the Generic tag to add styles</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/Generic.pdf">Generic.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/Glossary.java">Glossary</a><br><div class="description">Other use of the Generic tag: register keywords for a glossary</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/Glossary.pdf">Glossary.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/Width.java">Width</a><br><div class="description">How to measure and scale the width of a Chunk</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/Width.pdf">Width.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/EndOfLine.java">EndOfLine</a><br><div class="description">What happens when the end of the line is reached?</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/EndOfLine.pdf">EndOfLine.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/SplitChar.java">SplitChar</a><br><div class="description">Defining Split Characters</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/SplitChar.pdf">SplitChar.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/Hyphenation.java">Hyphenation</a><br><div class="description">Using auto-hyphenation</div><div class="small">Extra jars needed:</div><ul><li>itext-hyph-xml.jar</li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/chunk/Hyphenation.pdf">Hyphenation.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./objects/chunk/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="objects/anchors/index.html" name="objects_anchors">Anchors, Actions and Annotations</a>Deals with all the RemoteGoto, LocalGoto, Action, Annotation,... functionality</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="objects/anchors/index.html#inaction" class="small">In the book</a></li><li><a href="objects/anchors/index.html#localgoto" class="small">Local Goto and Local Destination</a></li><li><a href="objects/anchors/index.html#remotegoto" class="small">Remote Goto</a></li><li><a href="objects/anchors/index.html#anchor" class="small">the Anchor object</a></li><li><a href="objects/anchors/index.html#actions" class="small">Actions</a></li><li><a href="objects/anchors/index.html#annotation" class="small">Annotations</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/LocalGoto.java">LocalGoto</a><br><div class="description">Creates a document with a local goto and a local destination</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/LocalGoto.pdf">LocalGoto.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/LocalDestination.java">LocalDestination</a><br><div class="description">Creates a document that jumps to a local destination upon opening</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/LocalDestination.pdf">LocalDestination.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/RemoteGoto.java">RemoteGoto</a><br><div class="description">Creates two documents with links to eachother and to an external URL</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/DocumentA.pdf">DocumentA.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/DocumentB.pdf">DocumentB.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/AHref.java">AHref</a><br><div class="description">Using the Anchor object</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/AHref.pdf">AHref.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/AHref.html">AHref.html</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/NamedActions.java">NamedActions</a><br><div class="description">Creates a document with named actions.</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/NamedActions.pdf">NamedActions.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/JavaScriptAction.java">JavaScriptAction</a><br><div class="description">Creates a document with a Javascript action.</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/JavaScriptAction.pdf">JavaScriptAction.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/Actions.java">Actions</a><br><div class="description">Creates a document with some goto actions</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/Actions.pdf">Actions.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/remote.pdf">remote.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/ChainedActions.java">ChainedActions</a><br><div class="description">Creates a document with chained actions.</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/ChainedActions.pdf">ChainedActions.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/OpenApplication.java">OpenApplication</a><br><div class="description">Creates a document with a link to open an external application.</div><div class="small">Argument(s):</div><ul><li>C://windows/</li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/OpenApplication.pdf">OpenApplication.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/SimpleAnnotations.java">SimpleAnnotations</a><br><div class="description">Creates two documents with different types of annotations</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/cards.mpg">cards.mpg</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/iText.gif">iText.gif</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/SimpleAnnotations1.pdf">SimpleAnnotations1.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/SimpleAnnotations2.pdf">SimpleAnnotations2.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/Annotations.java">Annotations</a><br><div class="description">Creates a document with some PdfAnnotations</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/cards.mpg">cards.mpg</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/anchors/Annotations.pdf">Annotations.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./objects/anchors/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="objects/bookmarks/index.html" name="objects_bookmarks">Viewerpreferences, Pagelabels, Optional Content and Bookmarks</a>Deals with all the PDF Viewerpreferences, Bookmarks, Outlines, Destinations,... functionality</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="objects/bookmarks/index.html#inaction" class="small">In the book</a></li><li><a href="objects/bookmarks/index.html#viewerprefs" class="small">Viewerpreferences</a></li><li><a href="objects/bookmarks/index.html#pagelabels" class="small">Pagelabels</a></li><li><a href="objects/bookmarks/index.html#layers" class="small">Optional Content</a></li><li><a href="objects/bookmarks/index.html#bookmarks" class="small">Bookmarks</a></li><li><a href="objects/bookmarks/index.html#destinations" class="small">Creating Destinations</a></li><li><a href="objects/bookmarks/index.html#outlineactions" class="small">Outlines and Actions</a></li><li><a href="objects/bookmarks/index.html#chapter" class="small">the Chapter and Section object</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/bookmarks/ViewerPreferences.java">ViewerPreferences</a><br><div class="description">Creates five versions of the same document, but with different viewerpreferences</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/bookmarks/TwoColumnLeft.pdf">TwoColumnLeft.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/bookmarks/HideMenuToolbar.pdf">HideMenuToolbar.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/bookmarks/FullScreen.pdf">FullScreen.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/bookmarks/WithTitle.pdf">WithTitle.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/bookmarks/NoScaling.pdf">NoScaling.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/bookmarks/PageLabels.java">PageLabels</a><br><div class="description">Creates a document with pagelabels</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/bookmarks/PageLabels.pdf">PageLabels.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/bookmarks/Layers.java">Layers</a><br><div class="description">Creates a document with text in different layers</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/bookmarks/Layers.pdf">Layers.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/bookmarks/Bookmarks.java">Bookmarks</a><br><div class="description">Creates a document with Bookmarks for every new Paragraph that is added</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/bookmarks/Bookmarks.pdf">Bookmarks.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/bookmarks/Destinations.java">Destinations</a><br><div class="description">Creates a document with destinations that can be called from Bookmarks</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/bookmarks/Destinations.pdf">Destinations.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/bookmarks/OutlineActions.java">OutlineActions</a><br><div class="description">Creates a document with external destinations or actions that can be called from Bookmarks</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/bookmarks/OutlineActions.pdf">OutlineActions.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/bookmarks/remote.pdf">remote.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/bookmarks/ChapterSection.java">ChapterSection</a><br><div class="description">Creates a document with Chapters and Sections (automatic outlines)</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/bookmarks/ChapterSection.pdf">ChapterSection.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/bookmarks/HtmlIndex.java">HtmlIndex</a><br><div class="description">Creates an HTML index of a file that has bookmarks</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/bookmarks/ChapterSection_index.html">ChapterSection_index.html</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/bookmarks/OutlineActions_index.html">OutlineActions_index.html</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./objects/bookmarks/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="objects/images/index.html" name="objects_images">Images</a>Deals with all types of images that are supported by iText</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="objects/images/index.html#inaction" class="small">In the book</a></li><li><a href="objects/images/index.html#intro" class="small">Images</a></li><li><a href="objects/images/index.html#alignment" class="small">Image alignment</a></li><li><a href="objects/images/index.html#transformations" class="small">Image transformations</a></li><li><a href="objects/images/index.html#special" class="small">Some special features</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/Images.java">Images</a><br><div class="description">Adds different formats of images to a document.</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/otsoe.jpg">otsoe.jpg</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/iText.bmp">iText.bmp</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/pngnow.png">pngnow.png</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/iText.tif">iText.tif</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/getacro.gif">getacro.gif</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/iText.wmf">iText.wmf</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/Images.pdf">Images.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/RawData.java">RawData</a><br><div class="description">Using raw image data to construct an Image object.</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/otsoe.jpg">otsoe.jpg</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/rawdata.pdf">rawdata.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/AwtImage.java">AwtImage</a><br><div class="description">Using a java.awt.Image object to construct an Image object.</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/H.gif">H.gif</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/awt_image.pdf">awt_image.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/Alignment.java">Alignment</a><br><div class="description">Alignment of images.</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/vonnegut.gif">vonnegut.gif</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/otsoe.jpg">otsoe.jpg</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/hitchcock.png">hitchcock.png</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/alignment.pdf">alignment.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/ImagesAlignment.java">ImagesAlignment</a><br><div class="description">Alignment and wrapping of images.</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/vonnegut.gif">vonnegut.gif</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/otsoe.jpg">otsoe.jpg</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/hitchcock.png">hitchcock.png</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/imagesAlignment.pdf">imagesAlignment.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/ImageSequence.java">ImageSequence</a><br><div class="description">Adds images to a document, once respecting the order in which they were added, once in the default order.</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/otsoe.jpg">otsoe.jpg</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/getacro.gif">getacro.gif</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/inSequence.pdf">inSequence.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/notInSequence.pdf">notInSequence.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/AbsolutePositions.java">AbsolutePositions</a><br><div class="description">Adding an Image at absolute positions.</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/hitchcock.png">hitchcock.png</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/absolutepositions.pdf">absolutepositions.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/Scaling.java">Scaling</a><br><div class="description">Scaling images.</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/otsoe.jpg">otsoe.jpg</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/scaling.pdf">scaling.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/DvdCover.java">DvdCover</a><br><div class="description">Make a DVD Cover.</div><div class="small">Argument(s):</div><ul><li>dvdcover.pdf</li><li>My Sunflower Movie</li><li>808080</li><li>sunflower-front.jpg</li><li>sunflower-back.jpg</li></ul><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/sunflower-front.jpg">sunflower-front.jpg</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/sunflower-back.jpg">sunflower-back.jpg</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/dvdcover.pdf">dvdcover.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/Rotating.java">Rotating</a><br><div class="description">Rotating images.</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/otsoe.jpg">otsoe.jpg</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/rotating.pdf">rotating.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/AnnotatedImage.java">AnnotatedImage</a><br><div class="description">images and annotations.</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/otsoe.jpg">otsoe.jpg</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/iText.wmf">iText.wmf</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/annotated_images.pdf">annotated_images.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/ImageChunks.java">ImageChunks</a><br><div class="description">Images wrapped in a Chunk.</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/pngnow.png">pngnow.png</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/imageChunks.pdf">imageChunks.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/ImageMasks.java">ImageMasks</a><br><div class="description">Applying a mask to an image.</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/otsoe.jpg">otsoe.jpg</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/maskedImages.pdf">maskedImages.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./objects/images/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="objects/images/tiff/index.html" name="objects_images_tiff">Selected examples: EPS, TIFF, Barcodes</a>Selected examples: Embedding PostScript, importing TIFF files, Barcodes</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="objects/images/tiff/index.html#inaction" class="small">In the book</a></li><li><a href="objects/images/tiff/index.html#eps" class="small">Encapsulated PostScript</a></li><li><a href="objects/images/tiff/index.html#tiff" class="small">Tiff</a></li><li><a href="objects/images/tiff/index.html#barcode" class="small">Barcodes</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/tiff/EncapsulatedPostScript.java">EncapsulatedPostScript</a><br><div class="description">Adding EPS to PDF</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/tiff/parrot.ps">parrot.ps</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/tiff/tiger.ps">tiger.ps</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/tiff/eps.pdf">eps.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/tiff/Tiff2Pdf.java">Tiff2Pdf</a><br><div class="description">Converts some tiff files to PDF</div><div class="small">Argument(s):</div><ul><li>12.tif</li><li>338814-00.tif</li><li>even.tif</li><li>odd.tif</li></ul><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/tiff/12.tif">12.tif</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/tiff/338814-00.tif">338814-00.tif</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/tiff/odd.tif">odd.tif</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/tiff/even.tif">even.tif</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/tiff/12.pdf">12.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/tiff/338814-00.pdf">338814-00.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/tiff/even.pdf">even.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/tiff/odd.pdf">odd.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/tiff/OddEven.java">OddEven</a><br><div class="description">Combines 2 tiffs, one with odd, another with even pages into 1 combined PDF</div><div class="small">Argument(s):</div><ul><li>odd.tif</li><li>even.tif</li><li>combined.pdf</li></ul><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/tiff/odd.tif">odd.tif</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/tiff/even.tif">even.tif</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/tiff/combined.pdf">combined.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/tiff/Barcodes.java">Barcodes</a><br><div class="description">List with different barcodes</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/tiff/barcodes.pdf">barcodes.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/tiff/ExampleEAN128.java">ExampleEAN128</a><br><div class="description">Example barcode ean128</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/tiff/ean128.pdf">ean128.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/tiff/ExamplePDF417.java">ExamplePDF417</a><br><div class="description">Example barcode pdf417</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/images/tiff/pdf417.pdf">pdf417.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./objects/images/tiff/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="objects/tables/index.html" name="objects_tables">Tables</a>How to organize text and data in tables with iText</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="objects/tables/index.html#inaction" class="small">In the book</a></li><li><a href="objects/tables/index.html#intro" class="small">My First PdfPTable</a></li><li><a href="objects/tables/index.html#tablewidths" class="small">Widths, alignment and spacing</a></li><li><a href="objects/tables/index.html#addingcells" class="small">Adding PdfPCells</a></li><li><a href="objects/tables/index.html#styles" class="small">Cellheights, -alignment, -padding, -leading, -colors</a></li><li><a href="objects/tables/index.html#nextpage" class="small">Splitting tables over several pages</a></li><li><a href="objects/tables/index.html#continued" class="small">To be continued</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/MyFirstTable.java">MyFirstTable</a><br><div class="description">Use a PdfPTable to add a table to a PDF document</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/MyFirstTable.pdf">MyFirstTable.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/TableWidthAlignment.java">TableWidthAlignment</a><br><div class="description">Changing the width and the alignment of the complete table</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/TableWidthAlignment.pdf">TableWidthAlignment.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/TableSpacing.java">TableSpacing</a><br><div class="description">Defining the spacing between the table and other content</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/TableSpacing.pdf">TableSpacing.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/CellWidths.java">CellWidths</a><br><div class="description">Changing the widths of columns</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/CellWidths.pdf">CellWidths.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/DefaultCell.java">DefaultCell</a><br><div class="description">Using getDefaultCell to change the default style</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/DefaultCell.pdf">DefaultCell.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/NestedTables.java">NestedTables</a><br><div class="description">Using nested tables</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/NestedTables.pdf">NestedTables.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/ImageCell.java">ImageCell</a><br><div class="description">Adding an Image to a table</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/otsoe.jpg">otsoe.jpg</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/ImageCell.pdf">ImageCell.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/CellHeights.java">CellHeights</a><br><div class="description">Playing with heights of PdfPCells</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/CellHeights.pdf">CellHeights.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/CellAlignment.java">CellAlignment</a><br><div class="description">Changing the alignment of the contents of a PdfPCell</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/Alignment.pdf">Alignment.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/CellPaddingLeading.java">CellPaddingLeading</a><br><div class="description">Changing the padding and the leading of the contents of a PdfPCell</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/PaddingLeading.pdf">PaddingLeading.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/CellColors.java">CellColors</a><br><div class="description">Using some Rectangle methods on PdfPCell</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/CellColors.pdf">CellColors.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/TableBorders.java">TableBorders</a><br><div class="description">Demonstrates different borderstyles</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/TableBorders.pdf">TableBorders.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/AddBigTable.java">AddBigTable</a><br><div class="description">A very big table added with document.add()</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/AddBigTable.pdf">AddBigTable.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/SplitRows.java">SplitRows</a><br><div class="description">Add a table to a PDF with document.add() and if the cell doesn't fit, the row is split in two parts</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/SplitRowsBetween.pdf">SplitRowsBetween.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/SplitRowsWithin.pdf">SplitRowsWithin.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/OmitRows.pdf">OmitRows.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./objects/tables/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="objects/tables/pdfptable/index.html" name="objects_tables_pdfptable">PdfPTable</a>Some extra PdfPTable functionality</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="objects/tables/pdfptable/index.html#inaction" class="small">In the book</a></li><li><a href="objects/tables/pdfptable/index.html#" class="small">Adding a PdfPTable at an absolute position</a></li><li><a href="objects/tables/pdfptable/index.html#memory" class="small">Memory management for large tables</a></li><li><a href="objects/tables/pdfptable/index.html#cellevents" class="small">Cell and Table Events</a></li><li><a href="objects/tables/pdfptable/index.html#verticaltext" class="small">Vertical Text</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/pdfptable/WriteSelectedRows.java">WriteSelectedRows</a><br><div class="description">Demonstrates the writeSelectedRows method</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/pdfptable/WriteSelectedRows.pdf">WriteSelectedRows.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/pdfptable/Tables.java">Tables</a><br><div class="description">Adds a table to an absolute position</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/pdfptable/tables.pdf">tables.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/pdfptable/SplitTable.java">SplitTable</a><br><div class="description">Demonstrates how to split a Table in two sections of columns</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/pdfptable/SplitTable.pdf">SplitTable.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/pdfptable/FragmentTable.java">FragmentTable</a><br><div class="description">Break one large Table up into different smaller tables with the same header</div><div class="small">Argument(s):</div><ul><li>50</li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/pdfptable/FragmentTable.pdf">FragmentTable.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/pdfptable/CellEvents.java">CellEvents</a><br><div class="description">Demonstrates what one can do with cell events</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/pdfptable/otsoe.jpg">otsoe.jpg</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/pdfptable/CellEvents.pdf">CellEvents.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/pdfptable/TableEvents1.java">TableEvents1</a><br><div class="description">Demonstrates what one can do with table events</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/pdfptable/TableEvents1.pdf">TableEvents1.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/pdfptable/TableEvents2.java">TableEvents2</a><br><div class="description">Demonstrates what one can do with table events (cells with colspan &gt; 1)</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/pdfptable/TableEvents2.pdf">TableEvents2.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/pdfptable/FloatingBoxes.java">FloatingBoxes</a><br><div class="description">Demonstrates how to simulate cellspacing as in HTML</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/pdfptable/FloatingBoxes.pdf">FloatingBoxes.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/pdfptable/VerticalTextInCells.java">VerticalTextInCells</a><br><div class="description">Demonstrates how to add vertical text in a cell</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/pdfptable/VerticalText.pdf">VerticalText.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./objects/tables/pdfptable/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="objects/tables/alternatives/index.html" name="objects_tables_alternatives">Alternatives for PdfPTable</a>Some alternative ways to create a Table</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="objects/tables/alternatives/index.html#inaction" class="small">In the book</a></li><li><a href="objects/tables/alternatives/index.html#jtable" class="small">JTable to PDF</a></li><li><a href="objects/tables/alternatives/index.html#table" class="small">the Table object</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/alternatives/JTable2Pdf.java">JTable2Pdf</a><br><div class="description">Print a Swing jTable to a PDF file</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/alternatives/jTable.pdf">jTable.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/alternatives/OldTable.java">OldTable</a><br><div class="description">Generates a table with the Table object</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/alternatives/oldtable.pdf">oldtable.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/alternatives/LargeCell.java">LargeCell</a><br><div class="description">Trying to fit a Cell on a page</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/alternatives/largecell.pdf">largecell.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/alternatives/TablePdfPTable.java">TablePdfPTable</a><br><div class="description">Generates a table with the TableAttributes object</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/alternatives/tableattributes.pdf">tableattributes.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/alternatives/tableattributes.rtf">tableattributes.rtf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/alternatives/PaddingBorders.java">PaddingBorders</a><br><div class="description">Generates tables with different padding, bordercolors and borderwidths</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/alternatives/paddingborders.pdf">paddingborders.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/alternatives/MyFirstTable.java">MyFirstTable</a><br><div class="description">Generate a table with the Table/PdfPTable object</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/alternatives/MyFirstTable.pdf">MyFirstTable.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/alternatives/SpecificCells.java">SpecificCells</a><br><div class="description">Adding Cells at specific positions</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/alternatives/specificcells.pdf">specificcells.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/alternatives/RepeatingTable.java">RepeatingTable</a><br><div class="description">Shows how a table is split if it doesn't fit the page</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/alternatives/repeatingtable.pdf">repeatingtable.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/alternatives/NestedTables.java">NestedTables</a><br><div class="description">Nested tables</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/alternatives/nestedtables.pdf">nestedtables.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/alternatives/TableWithImage.java">TableWithImage</a><br><div class="description">Generate a table with the Table object containing Images</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/alternatives/otsoe.jpg">otsoe.jpg</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/alternatives/iText.gif">iText.gif</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/tables/alternatives/imageTable.pdf">imageTable.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./objects/tables/alternatives/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="objects/columns/index.html" name="objects_columns">ColumnText</a>How to organize text and data in columns with iText</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="objects/columns/index.html#inaction" class="small">In the book</a></li><li><a href="objects/columns/index.html#introduction" class="small">Columns</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/columns/Column.java">Column</a><br><div class="description">Defining a simple single object ColumnText object</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/columns/column.pdf">column.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/columns/ColumnSimple.java">ColumnSimple</a><br><div class="description">Adding phrases to a simple ColumnText object</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/columns/columnsimple.pdf">columnsimple.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/columns/ColumnObjects.java">ColumnObjects</a><br><div class="description">Adding different objects to a simple ColumnText object</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/columns/cover.png">cover.png</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/columns/columnobjects.pdf">columnobjects.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/columns/ColumnIrregular.java">ColumnIrregular</a><br><div class="description">Defining an irregular ColumnText object</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/columns/caesar_coin.jpg">caesar_coin.jpg</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/columns/columnirregular.pdf">columnirregular.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/columns/MultiColumnSimple.java">MultiColumnSimple</a><br><div class="description">Defining a simple MultiColumnText object</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/columns/multicolumnsimple.pdf">multicolumnsimple.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/columns/MultiColumnR2L.java">MultiColumnR2L</a><br><div class="description">Defining a MultiColumnText object that adds its columns from right to left</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/columns/multicolumnR2L.pdf">multicolumnR2L.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/objects/columns/MultiColumnIrregular.java">MultiColumnIrregular</a><br><div class="description">Defining an irregular MultiColumnText object</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/objects/columns/multicolumnirregular.pdf">multicolumnirregular.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./objects/columns/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><a class="top" href="#top">Go to top of the page</a><a name="part3"></a><div class="title">Part III: Fonts</div><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="fonts/index.html" name="fonts">The Font objects</a>Describes the different Font objects in iText.</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="fonts/index.html#inaction" class="small">In the book</a></li><li><a href="fonts/index.html#font" class="small">The Font-class</a></li><li><a href="fonts/index.html#fontfactory" class="small">The FontFactory-class</a></li><li><a href="fonts/index.html#basefont" class="small">The BaseFont-class</a></li><li><a href="fonts/index.html#more" class="small">to be continued...</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/fonts/StandardType1Fonts.java">StandardType1Fonts</a><br><div class="description">Sums up the 14 Standard Type 1 Fonts</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/StandardType1Fonts.pdf">StandardType1Fonts.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/fonts/FontFactoryType1Fonts.java">FontFactoryType1Fonts</a><br><div class="description">Sums up the 14 Standard Type 1 Fonts (using the FontFactory)</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/FontFactoryType1Fonts.pdf">FontFactoryType1Fonts.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/fonts/TrueType.java">TrueType</a><br><div class="description">Using a True Type font</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/truetype.pdf">truetype.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/fonts/FullFontNames.java">FullFontNames</a><br><div class="description">Retrieving the full font name</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/fullfontname_arialbi.txt">fullfontname_arialbi.txt</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/fonts/ListEncodings.java">ListEncodings</a><br><div class="description">Asking the font for its available encodings</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/encodings.txt">encodings.txt</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/fonts/FontEncoding.java">FontEncoding</a><br><div class="description">Using a True Type font that will be embedded in the PDF</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/fontencoding.pdf">fontencoding.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/fonts/UnicodeExample.java">UnicodeExample</a><br><div class="description">Using BaseFont.IDENTITY_H as 'encoding'</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/unicode.pdf">unicode.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/fonts/EncodingFont.java">EncodingFont</a><br><div class="description">Using an encoding to display characters from other alphabets</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/encodingfont.pdf">encodingfont.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./fonts/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="fonts/styles/index.html" name="fonts_styles">Font characteristics</a>Changing the style of a Font.</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="fonts/styles/index.html#inaction" class="small">In the book</a></li><li><a href="fonts/styles/index.html#measuring" class="small">Width and heigths of glyphs</a></li><li><a href="fonts/styles/index.html#styles" class="small">Font Styles</a></li><li><a href="fonts/styles/index.html#direction" class="small">Direction</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/fonts/styles/WidthHeight.java">WidthHeight</a><br><div class="description">Asking a font for the width/height of a textstring</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/styles/widthheight.pdf">widthheight.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/fonts/styles/FixedFontWidth.java">FixedFontWidth</a><br><div class="description">Changing the width of the font glyphs</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/styles/fixedfontwidth.pdf">fixedfontwidth.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/fonts/styles/FontStylePropagation.java">FontStylePropagation</a><br><div class="description">Explains the mechanism of Font Style Propagation</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/styles/FontStylePropagation.pdf">FontStylePropagation.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/fonts/styles/ExtraStyles.java">ExtraStyles</a><br><div class="description">Demonstrates how to underline or strike through text</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/styles/ExtraStyles.pdf">ExtraStyles.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/styles/ExtraStyles.rtf">ExtraStyles.rtf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/styles/ExtraStyles.html">ExtraStyles.html</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/fonts/styles/FontColor.java">FontColor</a><br><div class="description">Shows how to change the color of a font</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/styles/FontColor.pdf">FontColor.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/fonts/styles/RightToLeft.java">RightToLeft</a><br><div class="description">Writing text from left to right</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/styles/righttoleft.pdf">righttoleft.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/fonts/styles/ComplexText.java">ComplexText</a><br><div class="description">Writing text from left to right at absolute positions</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/styles/complextext.pdf">complextext.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/fonts/styles/Vertical.java">Vertical</a><br><div class="description">Writing vertical text</div><div class="small">Extra jars needed:</div><ul><li>iTextAsian.jar</li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/styles/vertical.pdf">vertical.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./fonts/styles/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="fonts/getting/index.html" name="fonts_getting">Getting fonts</a>Overview of the different types of fonts supported by iText.</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="fonts/getting/index.html#inaction" class="small">In the book</a></li><li><a href="fonts/getting/index.html#standard" class="small">Fonts supported in iText</a></li><li><a href="fonts/getting/index.html#builtin" class="small">Built-in fonts</a></li><li><a href="fonts/getting/index.html#files" class="small">Fonts from files</a></li><li><a href="fonts/getting/index.html#jars" class="small">Fonts from jars (and font packs)</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/fonts/getting/TrueType.java">TrueType</a><br><div class="description">Using a True Type font</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/getting/truetype.pdf">truetype.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/fonts/getting/RegisterFont.java">RegisterFont</a><br><div class="description">Registering Fonts with the FontFactory</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/getting/registerfont.pdf">registerfont.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/getting/registered.txt">registered.txt</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/fonts/getting/FontFactoryStyles.java">FontFactoryStyles</a><br><div class="description">Changing the style of a fontfactory font</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/getting/fontfactorystyles.pdf">fontfactorystyles.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/fonts/getting/UsingFontFactory.java">UsingFontFactory</a><br><div class="description">Sums up the Fonts that are available in some standard font directories on your system</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/getting/FontFactory.pdf">FontFactory.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/fonts/getting/TrueTypeCollections.java">TrueTypeCollections</a><br><div class="description">True Type Collections</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/getting/truetypecollections.pdf">truetypecollections.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/getting/msgothic.txt">msgothic.txt</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/fonts/getting/OpenTypeFont.java">OpenTypeFont</a><br><div class="description">Using an Open Type Font with Compact Font Format (CFF) data only (no true type outlines)</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/getting/liz.otf">liz.otf</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/getting/opentypefont.pdf">opentypefont.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/fonts/getting/ChineseJapaneseKorean.java">ChineseJapaneseKorean</a><br><div class="description">Using CJK Fonts</div><div class="small">Extra jars needed:</div><ul><li>iTextAsian.jar</li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/fonts/getting/cjk.pdf">cjk.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./fonts/getting/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><a class="top" href="#top">Go to top of the page</a><a name="part4"></a><div class="title">Part IV: Direct Content</div><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="directcontent/index.html" name="directcontent">Direct Content</a>Add content directly to the PDF file using the PdfContentByte class.</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="directcontent/index.html#inaction" class="small">In the book</a></li><li><a href="directcontent/index.html#pdfsyntax" class="small">PDF Syntax</a></li><li><a href="directcontent/index.html#pdfcontentbyte" class="small">iText approach</a></li><li><a href="directcontent/index.html#templates" class="small">Using templates (Form XObjects)</a></li><li><a href="directcontent/index.html#Postscript" class="small">PostScript XObjects</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/Layers.java">Layers</a><br><div class="description">Explains the concept of PdfContentByte layers in iText</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/hitchcock.png">hitchcock.png</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/layers.pdf">layers.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/Templates.java">Templates</a><br><div class="description">Using templates</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/templates.pdf">templates.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/TemplateImages.java">TemplateImages</a><br><div class="description">Templates used as image</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/templateImages.pdf">templateImages.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./directcontent/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="directcontent/coordinates/index.html" name="directcontent_coordinates">Coordinate Systems</a>Coordinate Systems - changing the Current Transformation Matrix (CTM)</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="directcontent/coordinates/index.html#inaction" class="small">In the book</a></li><li><a href="directcontent/coordinates/index.html#xycoordinates" class="small">The coordinate system</a></li><li><a href="directcontent/coordinates/index.html#transform" class="small">Transformations</a></li><li><a href="directcontent/coordinates/index.html#templates" class="small">Adding PdfTemplates</a></li><li><a href="directcontent/coordinates/index.html#images" class="small">Adding Images</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/coordinates/XandYcoordinates.java">XandYcoordinates</a><br><div class="description">Puts some marks at specific X and Y coordinates; connects the marks with a line and puts some text next to the marks</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/coordinates/XandY.pdf">XandY.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/coordinates/UpsideDown.java">UpsideDown</a><br><div class="description">Same example as above, but now the origin is in the upper left corner</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/coordinates/upsidedown.pdf">upsidedown.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/coordinates/AffineTransformation.java">AffineTransformation</a><br><div class="description">Same example as above, but now the X and Y coordinates are scaled</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/coordinates/affinetransformation.pdf">affinetransformation.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/coordinates/Transformations.java">Transformations</a><br><div class="description">Add a template using different transformation matrices</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/coordinates/transformations.pdf">transformations.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/coordinates/TransformImage.java">TransformImage</a><br><div class="description">Add an image using different transformation matrices</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/coordinates/hitchcock.png">hitchcock.png</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/coordinates/transformimage.pdf">transformimage.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./directcontent/coordinates/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="directcontent/graphics/index.html" name="directcontent_graphics">Graphics State</a>Add graphics directly to the PDF file using the PdfContentByte class.</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="directcontent/graphics/index.html#inaction" class="small">In the book</a></li><li><a href="directcontent/graphics/index.html#pdfsyntax" class="small">PDF Syntax</a></li><li><a href="directcontent/graphics/index.html#state" class="small">Graphics State</a></li><li><a href="directcontent/graphics/index.html#parameters" class="small">Methods to change the parameters</a></li><li><a href="directcontent/graphics/index.html#paths" class="small">Path construction and painting</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/graphics/Literal.java">Literal</a><br><div class="description">Writing PDF Syntax directly to iText</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/graphics/literal.pdf">literal.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/graphics/State.java">State</a><br><div class="description">Changing the Graphics State with saveState and restoreState</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/graphics/state.pdf">state.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/graphics/GState.java">GState</a><br><div class="description">Changing the Graphics State with setGState</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/graphics/gstate.pdf">gstate.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/graphics/Circles.java">Circles</a><br><div class="description">Draws some concentric circles</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/graphics/circles.pdf">circles.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/graphics/Shapes.java">Shapes</a><br><div class="description">Draws some shapes</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/graphics/shapes.pdf">shapes.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./directcontent/graphics/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="directcontent/colors/index.html" name="directcontent_colors">Colors</a>Colors, Transparency, Spotcolors, Patterns and Shading.</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="directcontent/colors/index.html#inaction" class="small">In the book</a></li><li><a href="directcontent/colors/index.html#device" class="small">Device Color spaces</a></li><li><a href="directcontent/colors/index.html#spotcolors" class="small">Separation Color Spaces</a></li><li><a href="directcontent/colors/index.html#patterns" class="small">Patterns</a></li><li><a href="directcontent/colors/index.html#transparency" class="small">Transparency</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/colors/SpotColors.java">SpotColors</a><br><div class="description">Using spotcolors.</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/colors/spotcolor.pdf">spotcolor.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/colors/Pattern.java">Pattern</a><br><div class="description">A stencil example (you define a shape and a default color).</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/colors/pattern.pdf">pattern.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/colors/Patterns.java">Patterns</a><br><div class="description">Colored patterns.</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/colors/pngnow.png">pngnow.png</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/colors/patterns.pdf">patterns.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/colors/Shading.java">Shading</a><br><div class="description">Shading.</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/colors/shading.pdf">shading.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/colors/ShadingPattern.java">ShadingPattern</a><br><div class="description">Shading pattern.</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/colors/shading_pattern.pdf">shading_pattern.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/colors/Transparency.java">Transparency</a><br><div class="description">Reproducing PLATE 16 on p1053 in the PDF Reference Manual</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/colors/transparency.pdf">transparency.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/colors/Groups.java">Groups</a><br><div class="description">Making images transparent.</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/colors/groups.pdf">groups.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/colors/SoftMask.java">SoftMask</a><br><div class="description">Making images transparent.</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/colors/otsoe.jpg">otsoe.jpg</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/colors/softmask.pdf">softmask.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./directcontent/colors/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="directcontent/text/index.html" name="directcontent_text">Text</a>Add text content directly to the PDF file using the PdfContentByte class.</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="directcontent/text/index.html#inaction" class="small">In the book</a></li><li><a href="directcontent/text/index.html#pdfsyntax" class="small">PDF Syntax</a></li><li><a href="directcontent/text/index.html#text" class="small">Text State</a></li><li><a href="directcontent/text/index.html#fonts" class="small">Fonts</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/text/Text.java">Text</a><br><div class="description">Adding text at absolute positions</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/text/text.pdf">text.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/text/Logo.java">Logo</a><br><div class="description">Draws the iText logo</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/text/logo.pdf">logo.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./directcontent/text/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="directcontent/pageevents/index.html" name="directcontent_pageevents">Page Events</a>Add content directly to the PDF file using the PdfContentByte class.</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="directcontent/pageevents/index.html#inaction" class="small">In the book</a></li><li><a href="directcontent/pageevents/index.html#pageevents" class="small">Page Event Methods</a></li><li><a href="directcontent/pageevents/index.html#examples" class="small">Examples</a></li><li><a href="directcontent/pageevents/index.html#romeojuliet" class="small">Romeo and Juliet: XML to PDF</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/pageevents/EndPage.java">EndPage</a><br><div class="description">Headers and footers in an EndPage event</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/pageevents/endpage.pdf">endpage.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/pageevents/PageNumbersWatermark.java">PageNumbersWatermark</a><br><div class="description">Making a document with a header containing 'page x of y' and with a watermark on every page.</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/pageevents/logo.gif">logo.gif</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/pageevents/pageNumbersWatermark.pdf">pageNumbersWatermark.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/pageevents/Bookmarks.java">Bookmarks</a><br><div class="description">Using paragraph events</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/pageevents/bookmarks.pdf">bookmarks.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/pageevents/Events.java">Events</a><br><div class="description">Using PageEvents</div><div class="small">Extra jars needed:</div><ul><li>crimson.jar</li></ul><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/pageevents/tagmapRomeoJuliet.xml">tagmapRomeoJuliet.xml</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/pageevents/playRomeoJuliet.xml">playRomeoJuliet.xml</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/pageevents/RomeoJuliet.pdf">RomeoJuliet.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./directcontent/pageevents/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="directcontent/optionalcontent/index.html" name="directcontent_optionalcontent">Optional Content</a>Add optional content to a PDF file.</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="directcontent/optionalcontent/index.html#inaction" class="small">In the book</a></li><li><a href="directcontent/optionalcontent/index.html#ocg" class="small">Optional Content Groups</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/optionalcontent/OrderedLayers.java">OrderedLayers</a><br><div class="description">Ordering Optional Content Groups</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/optionalcontent/orderedlayers.pdf">orderedlayers.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/optionalcontent/ContentGroups.java">ContentGroups</a><br><div class="description">Grouping Optional Content</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/optionalcontent/contentgroups.pdf">contentgroups.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/optionalcontent/OptionalContent.java">OptionalContent</a><br><div class="description">Changing the visibility using an Action</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/optionalcontent/pngnow.png">pngnow.png</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/optionalcontent/optionalcontent.pdf">optionalcontent.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/optionalcontent/NestedLayers.java">NestedLayers</a><br><div class="description">Nesting Optional Content</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/optionalcontent/nestedlayers.pdf">nestedlayers.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/optionalcontent/Automatic.java">Automatic</a><br><div class="description">Automatic grouping and nesting of Optional Content</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/optionalcontent/automatic.pdf">automatic.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/optionalcontent/Layers.java">Layers</a><br><div class="description">Zooming and radio groups</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/optionalcontent/layers.pdf">layers.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./directcontent/optionalcontent/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="directcontent/graphics2D/index.html" name="directcontent_graphics2D">Graphics2D</a>If you don't want to read all the chapters on PDF syntax, just use the JAVA API</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="directcontent/graphics2D/index.html#inaction" class="small">In the book</a></li><li><a href="directcontent/graphics2D/index.html#graphics2D" class="small">The java.awt.Graphics2D object</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/graphics2D/G2D.java">G2D</a><br><div class="description">A Simple Graphics2D example</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/graphics2D/graphics2D.pdf">graphics2D.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/graphics2D/ArabicText.java">ArabicText</a><br><div class="description">Drawing arabic text using the Graphics2D object</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/graphics2D/arabictext.pdf">arabictext.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/graphics2D/JFreeChartExample.java">JFreeChartExample</a><br><div class="description">Some JFreeChart examples</div><div class="small">Extra jars needed:</div><ul><li>jfreechart.jar</li><li>jcommon.jar</li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/graphics2D/barchart.pdf">barchart.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/graphics2D/piechart.pdf">piechart.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/directcontent/graphics2D/xychart.pdf">xychart.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./directcontent/graphics2D/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><a class="top" href="#top">Go to top of the page</a><a name="part5"></a><div class="title">Part V: Interactive Features (AcroForms)</div><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="forms/index.html" name="forms">Interactive Forms</a>Step for step creation of an Acroform.</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="forms/index.html#inaction" class="small">In the book</a></li><li><a href="forms/index.html#acroform" class="small">Acroform</a></li><li><a href="forms/index.html#Fieldtypes" class="small">Field types</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/forms/FormPushButton.java">FormPushButton</a><br><div class="description">Generates a PDF with an Acroform containing a pushbutton</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/forms/pushbutton.pdf">pushbutton.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/forms/FormCheckbox.java">FormCheckbox</a><br><div class="description">Generates a PDF with an Acroform containing a checkbox</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/forms/checkbox.pdf">checkbox.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/forms/FormRadioButton.java">FormRadioButton</a><br><div class="description">Generates a PDF with an Acroform containing a radiobutton</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/forms/radiobutton.pdf">radiobutton.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/forms/FormTextField.java">FormTextField</a><br><div class="description">Generates a PDF with an Acroform containing a text field</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/forms/textfield.pdf">textfield.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/forms/SimpleRegistrationForm.java">SimpleRegistrationForm</a><br><div class="description">Generates a PdfPTable with some TextFields</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/forms/SimpleRegistrationForm.pdf">SimpleRegistrationForm.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/forms/FormCombo.java">FormCombo</a><br><div class="description">Generates a PDF with an Acroform containing a combobox</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/forms/combo.pdf">combo.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/forms/FormList.java">FormList</a><br><div class="description">Generates a PDF with an Acroform containing a list</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/forms/list.pdf">list.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/forms/TextFields.java">TextFields</a><br><div class="description">Generates a PDF with an Acroform containing text fields</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/forms/TextFields.pdf">TextFields.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/forms/FormSignature.java">FormSignature</a><br><div class="description">Generates a PDF with an Acroform containing a signature</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/forms/signature.pdf">signature.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/forms/ListFields.java">ListFields</a><br><div class="description">Reads different pdf fields and lists the acrofields</div><div class="small">Argument(s):</div><ul><li>pushbutton.pdf</li><li>radiobutton.pdf</li><li>checkbox.pdf</li><li>textfield.pdf</li><li>SimpleRegistrationForm.pdf</li><li>combo.pdf</li><li>list.pdf</li><li>TextFields.pdf</li><li>signature.pdf</li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/forms/listfields.txt">listfields.txt</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./forms/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="forms/create/index.html" name="forms_create">Creating Forms</a>Step for step creation of an Acroform.</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="forms/create/index.html#inaction" class="small">In the book</a></li><li><a href="forms/create/index.html#formelements" class="small">Form Elements</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/forms/create/StudentCard.java">StudentCard</a><br><div class="description">Generates a studentcard</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/forms/create/bruno.jpg">bruno.jpg</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/forms/create/studentcard.pdf">studentcard.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/forms/create/StudentCardForm.java">StudentCardForm</a><br><div class="description">Generates a studentcard as a form</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/forms/create/studentcardform.pdf">studentcardform.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./forms/create/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="forms/fill/index.html" name="forms_fill">Working with existing PDF documents</a>How-to copy/manipulate existing PDF documents.</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="forms/fill/index.html#inaction" class="small">In the book</a></li><li><a href="forms/fill/index.html#stamper" class="small">PdfStamper</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/forms/fill/Register.java">Register</a><br><div class="description">Fills in a form</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/forms/fill/SimpleRegistrationForm.pdf">SimpleRegistrationForm.pdf</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/forms/fill/registered.pdf">registered.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/forms/fill/registered_flat.pdf">registered_flat.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/forms/fill/FdfExample.java">FdfExample</a><br><div class="description">Creates an FDF and merges it with a PDF</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/forms/fill/SimpleRegistrationForm.pdf">SimpleRegistrationForm.pdf</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/forms/fill/SimpleRegistrationForm.fdf">SimpleRegistrationForm.fdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/forms/fill/registered_fdf.pdf">registered_fdf.pdf</a></li></ul></div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/forms/fill/XfdfExample.java">XfdfExample</a><br><div class="description">merges an XFDF file with a PDF</div><div class="small">Input:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/forms/fill/SimpleRegistrationForm.pdf">SimpleRegistrationForm.pdf</a></li><li><a href="http://itext.ugent.be/library/com/lowagie/examples/forms/fill/register.xfdf">register.xfdf</a></li></ul><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/forms/fill/registered_xfdf.pdf">registered_xfdf.pdf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./forms/fill/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><a class="top" href="#top">Go to top of the page</a><a name="part6"></a><div class="title">Part VI: RTF</div><table width="100%" border="0" cellspacing="3" cellpadding="3"><tr><td colspan="2"><a class="chapter" href="rtf/index.html" name="rtf">Rich Text Format</a>How-to generate RTF documents using iText.</td></tr><tr><td width="250" valign="top"><div class="subtitle">Sections</div><ul><li><a href="rtf/index.html#rtfpackage" class="small">The RTF Package</a></li><li><a href="rtf/index.html#introduction" class="small">Introduction to RTF</a></li><li><a href="rtf/index.html#creatingrtf" class="small">Creating a basic RTF document</a></li><li><a href="rtf/index.html#unsupported" class="small">Unsupported iText features</a></li><li><a href="rtf/index.html#transition" class="small">Transitioning from the RtfWriter to the RtfWriter2</a></li><li><a href="rtf/index.html#extendedhf" class="small">Extended header / footer support</a></li><li><a href="rtf/index.html#tocsupport" class="small">Table of contents support</a></li><li><a href="rtf/index.html#extendedcellborder" class="small">Extended cell border support</a></li><li><a href="rtf/index.html#pagenumberelement" class="small">Page number element</a></li><li><a href="rtf/index.html#diskcaching" class="small">Using a Disk Cache for document generation</a></li></ul></td><td valign="top"><div class="subtitle">Examples</div><div class="example"><a class="source" href="http://itext.ugent.be/library/com/lowagie/examples/rtf/HelloWorld.java">HelloWorld</a><br><div class="description">Generates a simple 'Hello World!' RTF file</div><div class="small">Output:</div><ul><li><a href="http://itext.ugent.be/library/com/lowagie/examples/rtf/HelloWorld.rtf">HelloWorld.rtf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./rtf/build.xml">
					build.xml
				</a></li></ul></div></td></tr></table><a class="top" href="#top">Go to top of the page</a><div id="footer" xmlns="http://www.w3.org/1999/xhtml">
			Page Updated: 2006/09/17 10:13:49
			Copyright &copy; 1999-2005
			<br><a href="http://www.lowagie.com/iText/">iText</a> is a Free Java-Pdf library by Bruno Lowagie and Paulo Soares.
		</div></div><div class="commercial"><br><script type="text/javascript"><!--
google_ad_client = "pub-0340380473790570";
google_ad_width = 120;
google_ad_height = 600;
google_ad_format = "120x600_as";
google_ad_channel ="";
google_ad_type = "text_image";
google_color_border = "FFFFFF";
google_color_bg = "FFFFFF";
google_color_link = "1B09BD";
google_color_url = "100670";
google_color_text = "707070";
//--></script><script type="text/javascript" src="http://pagead2.googlesyndication.com/pagead/show_ads.js"></script><br><br><div class="subtitle">Amazon books:</div><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=8&l=as1&asins=1932394796&fc1=000000&lc1=0000ff&bc1=&lt1=_blank&IS2=1&bg1=ffffff&f=ifr" width="120" height="240" scrolling="no" marginwidth="0" marginheight="0" frameborder="0" align="Center"></iframe>');
//--></script><a xmlns="" href="http://www.amazon.co.uk/exec/obidos/ASIN/1932394796/catloogjecom-21" class="amazonlinks">
			amazon.co.uk-link
		</a><br><br><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=8&l=as1&asins=0321304748&fc1=000000&lc1=0000ff&bc1=&lt1=_blank&IS2=1&bg1=ffffff&f=ifr" width="120" height="240" scrolling="no" marginwidth="0" marginheight="0" frameborder="0" align="Center"></iframe>');
//--></script><a href="http://www.amazon.co.uk/exec/obidos/ASIN/0321304748/catloogjecom-21" class="amazonlinks">
			amazon.co.uk-link
		</a><br><br><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=10&l=st1&mode=books&search=PDF&=1&fc1=&lc1=&lt1=&bg1=&f=ifr" width="120" height="460" border="0" frameborder="0" style="border:none;" scrolling="no" marginwidth="0" marginheight="0"></iframe>');
//--></script><br><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=10&l=st1&mode=books&search=JAVA&=1&fc1=&lc1=&lt1=&bg1=&f=ifr" width="120" height="460" border="0" frameborder="0" style="border:none;" scrolling="no" marginwidth="0" marginheight="0"></iframe>');
//--></script><br></div></body></html>